<?
include_spip('base/abstract_sql');
include_spip('inc/texte');

function remove_favori($id_favori, $id_liste, $id_auteur){
	//check if the author is the owner of the favori or id_auteur=0 (admin)
	if(favoris_auteur_possede_favori($id_auteur, $id_favori) || $id_auteur==0){
		//then delete the link between favori and favliste
		spip_query("delete from spip_favoris_favlistes where id_favori=".sql_quote($id_favori)." and id_liste=".sql_quote($id_liste));
		//check if favori still contained in a list
		if(sql_count(spip_query("select id_favori from spip_favoris_favlistes where id_favori=".sql_quote($id_favori)." limit 1"))==0){
			//if not anywhere we delete the favori
			spip_query("delete from spip_favoris where id_favori=".sql_quote($id_favori));
		}
		if(mysql_affected_rows()>0) return true;
	}
	return false;
}

function remove_liste($id_liste, $id_auteur){
	//check if the author is the owner of the list
	if(favoris_auteur_possede_liste($id_auteur, $id_liste)){
		//first delete all the links to this list
		$res = spip_query("select id_favori from spip_favoris_favlistes where id_liste=".sql_quote($id_liste));
		while($row = sql_fetch($res)){
			$id_favori = $row['id_favori'];
			//delete favorite from list
			remove_favori($id_favori, $id_liste, $id_auteur);
		}
		//then we delete the list
		spip_query("delete from spip_favlistes where id_liste=".sql_quote($id_liste));
	}
	else return false;
	return true;
}

function edit_liste($id_liste, $id_auteur, $nom, $acces){
	//check if author owns the list
	if(favoris_auteur_possede_liste($id_auteur, $id_liste)){
		//if list unchanged, we do nothing and return true (no error)
		if(sql_count(spip_query("select id_auteur from spip_favlistes where id_auteur=".sql_quote($id_auteur)." and id_liste=".sql_quote($id_liste)." and nom=".sql_quote($nom)." and acces=".sql_quote($acces)." limit 1"))==0){
			//else we try to update the list
			spip_query("update spip_favlistes set nom=".sql_quote(safehtml($nom)).", acces=".sql_quote(safehtml($acces))." where id_liste=$id_liste");
			if(mysql_affected_rows()>0) return true;
		}
		else return true;
	}
	return false;
}

//create a list if doesn't exist
function create_liste($nom, $acces, $id_auteur){
	$res = spip_query("select id_liste from spip_favlistes where id_auteur=".sql_quote($id_auteur)." and nom=".sql_quote($nom)." limit 1");
	if($row = sql_fetch($res)) return $row['id_liste'];
	spip_query("insert into spip_favlistes (nom, acces, id_auteur) values(".sql_quote(safehtml($nom)).", ".sql_quote(safehtml($acces)).", ".sql_quote($id_auteur).")");
	$id_liste = mysql_insert_id();
	return $id_liste;
}


//create a favorite if doesn't exist
function create_favori($objet, $id_objet, $id_auteur){
	$res = spip_query("select id_favori from spip_favoris where id_auteur=".sql_quote($id_auteur)." and objet=".sql_quote($objet)." and id_objet=".sql_quote($id_objet)." limit 1");
	if($row = sql_fetch($res)) $id_favori = $row['id_favori'];
	else{
		spip_query("insert into spip_favoris(id_auteur, objet, id_objet) values(".sql_quote($id_auteur).", ".sql_quote(safehtml($objet)).", ".sql_quote($id_objet).")");
		$id_favori = mysql_insert_id();
	}
	return $id_favori;
}

//this will add a favorite to a list
function add_favori($id_favori, $id_liste, $id_auteur){
	//check if the author is the owner of both the list and the favori, or only owner of the favorite and admin owns the list
	if((favoris_auteur_possede_liste($id_auteur, $id_liste) || favoris_auteur_possede_liste(0, $id_liste)) && favoris_auteur_possede_favori($id_auteur, $id_favori)){
		//test if link already exists, if not we create it
		if(sql_count(spip_query("select id_favori from spip_favoris_favlistes where id_favori=".sql_quote($id_favori)." and id_liste=".sql_quote($id_liste)." limit 1"))==0){
			spip_query("insert into spip_favoris_favlistes(id_favori, id_liste) values(".sql_quote($id_favori).", ".sql_quote($id_liste).")");
			if(mysql_affected_rows()>0) return true;
		}
		else return true;
	}
	return false;
}

function favoris_auteur_possede_liste($id_auteur, $id_liste){
	if(sql_count(spip_query("select id_liste from spip_favlistes where id_liste=".sql_quote($id_liste)." and id_auteur=".sql_quote($id_auteur)." limit 1"))==1) return true;
	else return false;
}

function favoris_auteur_possede_favori($id_auteur, $id_favori){
	if(sql_count(spip_query("select id_auteur from spip_favoris where id_auteur=".sql_quote($id_auteur)." and id_favori=".sql_quote($id_favori)." limit 1"))==1) return true;
	else return false;
}

function favoris_set_position_liste($id_liste, $pos){
	spip_query("update spip_favlistes set position=".sql_quote($pos)." where id_liste=".sql_quote($id_liste));
}

function favoris_set_position_favori($id_favori, $id_liste, $pos){
	spip_query("update spip_favoris_favlistes set position=".sql_quote($pos)." where id_favori=".sql_quote($id_favori)." and id_liste=".sql_quote($id_liste));
}

function favoris_liste_exists($nom_liste, $id_auteur){
	$res = spip_query("select id_liste from spip_favlistes where id_auteur=".sql_quote($id_auteur)." and nom like ".sql_quote($nom_liste)." limit 1");
	if(sql_count($res)==0) return false;
	else $row = sql_fetch($res);
	return $row['id_liste'];
}

function favoris_objet_exists($objet){
	if(isset($GLOBALS['favoris_objets'][$objet])) return true;
	if(sql_count(spip_query("select id_cfg_objet from spip_favoris_cfg_objets where nom=".sql_quote($objet)))>0) return true;
	return false;
}

function favoris_allow_ajax(){
	$meta = favoris_get_meta('mode_ajax');
	if($meta=='non') return false;
	return true;
}

function favoris_allow_cookies(){
	$meta = favoris_get_meta('mode_visiteur');
	if($meta=='cookies') return true;
	return false;
}

function favoris_allow_members(){
	$meta = favoris_get_meta('mode_acces');
	if($meta=='tous' || $meta=='membres') return true;
	return false;
}

function favoris_allow_visitors(){
	$meta = favoris_get_meta('mode_acces');
	if($meta=='tous' || $meta=='visiteurs') return true;
	return false;
}

function favoris_get_meta($param){
	$favoris = $GLOBALS['meta']['favoris'];
	$tab = unserialize($favoris);
	if($tab['favoris_'.$param]!='') return $tab['favoris_'.$param];
	else return $GLOBALS['favoris_defaut'][$param];
}



?>